/**
 * + Тут сложная работа с фокусом
 * Причина:
 * Поведение селекта отличается от ожидаемого, а именно работа с фокусом и блюром.
 * Ожидается что пока селект открыт и после выбора опции он остается в фокусе. Т.е. Когда мы на него
 * нажали и он открылся мы снаружи должны поймать onFocus. А onBlur снаружи мы должны поймать когда ушли из инпута, т.е. Кликнули
 * где то в другое место на странице (или нажали tab).
 * Данное поведение пришлось эмулировать кодом ниже, так как по клику на элемент выпадающего списка инпут терял фокус
 * так как это разные html элементы.
 *
 * + Логика работы:
 * Запоминаем фактический фокус и "фейковый" (externalFocused).
 * Состояние focused меняем по факут реального focus и blur
 * Фейковое меняем только если у нас не открыт список
 * (так как пока открыт список мы считаем что элемент в фокусе), + дергаем внешение коллбэки.
 * Но тут есть 2 хака:
 * 1. При выборе элемента мы насильно фокусим инпут (смотри ниже в handleSelectOption)
 * 2. Если мы видимо что выпадашка закрыта и фактическое значение фокуса отличается от фейкового то мы эмулируем блюр
 * (при этом передаем фактическое событие блюра, которое запомнили когда был реальный блюр)
 * Таким образом мы обрабатываем ситуацию когда нажали на инпут (он открылся и поймал фокус), а потом кликнули вне инпута. В этом случае
 * реальный фокус переходи в false а фейковый остается в true, поэтому приходится ручками обрабатывать этот кейс, что бы фейковый фокус тоже
 * перешел в false и был вызван внешний onBlur.
 */
export declare const useSelectFocus: (opened: boolean | undefined, onFocus: any, onBlur: any) => {
    focused: boolean;
    handleFocus: (e: any) => void;
    handleBlur: (e: any) => void;
};
